summaryrefslogtreecommitdiff
path: root/tests/cp/r-vs-symlink
diff options
context:
space:
mode:
Diffstat (limited to 'tests/cp/r-vs-symlink')
-rwxr-xr-xtests/cp/r-vs-symlink61
1 files changed, 61 insertions, 0 deletions
diff --git a/tests/cp/r-vs-symlink b/tests/cp/r-vs-symlink
new file mode 100755
index 0000000..9601fb6
--- /dev/null
+++ b/tests/cp/r-vs-symlink
@@ -0,0 +1,61 @@
+#!/bin/sh
+# cp -r should not create symlinks. Fixed in fileutils-4.1.5.
+
+# Copyright (C) 2001, 2002, 2004, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+# Restored old behavior (whereby cp -r preserves symlinks) in 4.1.6,
+# though now such usage evokes a warning:
+# cp: `slink': WARNING: using -r to copy symbolic links is not portable
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+fi
+
+. $srcdir/../envvar-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp;tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+echo abc > foo || framework_failure=1
+ln -s foo slink || framework_failure=1
+ln -s no-such-file no-file || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+# This would fail in 4.1.5, not in 4.1.6.
+cp -r no-file junk 2>/dev/null || fail=1
+
+cp -r slink bar 2>/dev/null || fail=1
+set x `ls -l bar`; shift; mode=$1
+case $mode in
+ l*) ;;
+ *) fail=1;;
+esac
+
+(exit $fail); exit $fail